"use strict";

exports.__esModule = true;
exports.useQuery = useQuery;

var _react = require("react");

var _generic = require("./generic");

var _use_client = require("./use_client");

function useQuery(query, options, callback, dependencies) {
  var _firstOfType;

  var client = (0, _use_client.useClient)();
  var actualOptions = (0, _generic.firstOfType)(_generic.isOptions, options);
  var actualCallback = (0, _generic.firstOfType)(_generic.isCallback, options, callback);
  var actualDependencies = (_firstOfType = (0, _generic.firstOfType)(_generic.isDependencies, options, callback, dependencies)) !== null && _firstOfType !== void 0 ? _firstOfType : [query, actualOptions, actualCallback].filter(function (i) {
    return i;
  });
  return (0, _react.useCallback)(function () {
    return client.query(query, actualOptions, actualCallback);
  }, [client].concat(actualDependencies));
}
//# sourceMappingURL=use_query.js.map